#include "installer.h"


struct tgt_object *stringuser, *stringname, *stringpass1, *stringpass2, 
				*userlist, *okb;
struct users {
		char user[20];
		char name[50];
		char password[20];
} userdb[20];

int udb = 0;

int xconfig_main();
int eth_main();
int root_main();
/* ==== functions ==== */
void user_next() {
	tgt_unlink(window);
	
	if (!server_edition && !firewall_edition) {
	 xconfig_main();
	} else { 
	 eth_main(); 
	}
	
	tgt_refresh(window);
}

void user_prev() {
	tgt_unlink(window);
	root_main();
	tgt_refresh(window);
}


int listfill_user(void **d, int c, int n, char *tmp, int k, int a) {
	if (c == TGT_LISTREQ_GETMAX) {
		return(udb); 
	} else {
	 snprintf(tmp,k,userdb[n].user,userdb[udb].user);
	}
	return (1);
}

void listdel(struct tgt_object *list, int n) {
	char temp1[30][20], temp2[30][50], temp3[30][15];
	int i = 0, j = 0, t;
	
	while ( j != udb ) {
	 if ( j != n ) { 
	  sprintf(temp1[i],"%s",userdb[j].user);  
	  sprintf(temp2[i],"%s",userdb[j].name);  
	  sprintf(temp3[i],"%s",userdb[j].password); 
	  i++; 
	 } 
	 j++;
	}
	t = i;
	i = 0;
	while ( i != t) {
	 sprintf(userdb[i].user,"%s",temp1[i]);
	 sprintf(userdb[i].name,"%s",temp2[i]);
	 sprintf(userdb[i].password,"%s",temp3[i]);
	 i++;
	}
	udb = i;
	tgt_refresh(userlist); 
}

void saveuser() {
	char *pass1, *pass2, *user, *name;
	int i, s = 0;
	
	tgt_get(stringpass1,TGTT_STRING_STRING,(tgtt*) &pass1); 
	tgt_get(stringpass2,TGTT_STRING_STRING,(tgtt*) &pass2);
 	tgt_get(stringuser,TGTT_STRING_STRING,(tgtt*) &user);
	tgt_get(stringname,TGTT_STRING_STRING,(tgtt*) &name);  
	
	if ( strlen(user) != 0) { 
	 
	    for (i = 0; i < udb; i++) {
		 if ( !(strcmp(user,userdb[i].user)) ) { s = 1; }
		}
	 if ( !s ) {
		
	  if ( !(strcmp(pass1,pass2)) ) {
	 
	   if ( strlen(pass1) < 6 ) {
		popupmsg("Hiba","A jelsz kevesebb mint 6 karakter !\n\n");
	   } else {
	    sprintf(userdb[udb].user,"%s",user);
		
	    if ( !(strlen(name)) ) { sprintf(name,"x"); }
		sprintf(userdb[udb].name,"%s",name); 
		
	    sprintf(userdb[udb].password,"%s",pass1);
	    udb++;
		tgt_refresh(userlist);
	   }
	  
	  } else { popupmsg("Hiba","A kt jelsz nem egyezik !\n\n"); }  
	 
	 } else { popupmsg("Hiba","Mr van ilyen felhasznl !\n\n"); }
	
	} else { popupmsg("Hiba","Addj meg felhasznl nevet !\n\n"); }
}	 
  
void saveuserdata() {
	int i;
	char tmpu[20], tmp[100];
	
	conf = tgt_load_conf(confile);
	  
	
	 for (i = 0; i < udb; i++) {
	  
	  	 
	  sprintf(tmpu,"user%d",i);
	  sprintf(tmp,"%s,%s,%s",userdb[i].user,userdb[i].name,userdb[i].password);
	  tgt_set_conf(conf,"users",tmpu,tmp);
	  	  
	 }
	 
	 tgt_save_conf(conf,confile);
	 tgt_unload_conf(conf);
	  
	 user_next();
	 
} 

/* main window */
void step_user () {
	struct tgt_object *line1, *b1, *b3,	*labelpass1, *labelpass2, 
						*labeluser, *labelname;
	
	window = tgt_createobject(TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU LINUX - Felhasznl hozzadsa",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0 
	});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	/* user */
	labeluser = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,12,
	TGTT_LABEL_TEXT, (tgtt) "Felhasznl:",	
	TGTT_END,0});
	
	stringuser = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,15,TGTT_Y,12,TGTT_XS,20,
	TGTT_STRING_MAX,20,
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	/* name */
	labelname = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,13,
	TGTT_LABEL_TEXT, (tgtt) "Nv:",	
	TGTT_END,0});
	
	stringname = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,15,TGTT_Y,13,TGTT_XS,20,
	TGTT_STRING_MAX,20,
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	/* passwords */
	labelpass1 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,14,
	TGTT_LABEL_TEXT, (tgtt) "Jelsz:",	
	TGTT_END,0});
	
	stringpass1 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,15,TGTT_Y,14,TGTT_XS,10,
	TGTT_STRING_MAX,10,
	TGTT_STRING_HASHED,'*',
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
		
	labelpass2 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,15,
	TGTT_LABEL_TEXT, (tgtt) "Mgegyszer:",	
	TGTT_END,0});
	
	stringpass2 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,15,TGTT_Y,15,TGTT_XS,10,
	TGTT_STRING_MAX,10,
	TGTT_STRING_HASHED,'*',
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	b3 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,2,TGTT_Y,17,
	TGTT_BUTTON_CAPTION, (tgtt) " Felvesz ",
	TGTT_CALLBACK, (tgtt) saveuser,
	TGTT_BG,1,
	TGTT_END,0});
	
	userlist = tgt_createandlink(window,TGT_CLASS_LIST,(tgtt[]) {
	TGTT_X,50,TGTT_Y,10,TGTT_XS,20,TGTT_YS,8,
	TGTT_LIST_ACTIVEBG,1,
	TGTT_LIST_FRAMECOLOR,6,
	TGTT_LIST_DATACALLBACK,(tgtt) listfill_user,
	TGTT_CALLBACK,(tgtt) listdel,
	TGTT_END,0});
	
	/* buttons */
	line1 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});
	
	okb = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,58,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) "  Ok  ",
	TGTT_CALLBACK, (tgtt) saveuserdata,
	TGTT_BG,1,
	TGTT_END,0});
	
	b1 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,16,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) " Vissza ",
	TGTT_CALLBACK, (tgtt) user_prev,
	TGTT_BG,1,
	TGTT_END,0});
	
}

int user_main () {
	helpnum = 8;	
	step_user();
	textarea("/usr/share/uhu-console-installer/text_user");
	tgt_setfocus(okb);
	
	return(0);
	
}
